import asyncio
import hashlib

from fastapi import APIRouter, Request
from pydantic import BaseModel, validator

from handler_data import HandlerUser, HandlerEvent
from settings import settings

router = APIRouter()
from models import UserModel


@router.post("/user/")
async def user(request: Request, item: UserModel):
    ta = getattr(request.app.state.ta, item.act)
    # 将不同游戏发送到不同 topic_name
    request.app.state.ta.consumer.topic_name = item.game
    rdb = request.app.state.redis
    await asyncio.gather(*map(lambda o: asyncio.create_task(o(rdb, item)), HandlerUser.handler_link))

    ta(item.distinct_id, item.account_id, item.properties)
    results = {"code": 0, 'msg': 'ok'}
    return results





